#
# source of parts of this file:
#     http://prestopronto.googlecode.com/svn/trunk/source/tables.py
#    (accessed 08 January 2013)
#
# based on:
#     "Gwyn P. Williams in
#      'X-ray Data Booklet; Section 1.1 - Electtron Binding Energies'
#     ",
#      http://xdb.lbl.gov/Section1/Sec_1-1.html
#
# source part of:
#     "Prestopronto - Software for analysis of Quick EXAFS and Dispersive XAFS data",
#     by Carmelo Pristipino, European Synchrotron Radiation Facility - ESRF, France
#     (http://www.esrf.eu/computing/scientific/PRESTOPRONTO/Prestopronto.htm)
#



## dspacing = {"Si 111": 3.13467, "Si 311" :1.63702, "Si 511" :1.04514 }
## elements = ["", "H" , "He", "Li", "Be", "B" , "C" , "N" , "O" , "F" , "Ne", "Na", "Mg", "Al", "Si", "P" , "S" , "Cl", "Ar", "K" , "Ca", "Sc", "Ti", "V" , "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As", "Se", "Br", "Kr", "Rb", "Sr", "Y" , "Zr", "Nb", "Mo", "Tc", "Ru", "Rh", "Pd", "Ag", "Cd", "In", "Sn", "Sb", "Te", "I" , "Xe", "Cs", "Ba", "La", "Ce", "Pr", "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", "Er", "Tm", "Yb", "Lu", "Hf", "Ta", "W" , "Re", "Os", "Ir", "Pt", "Au", "Hg", "Tl", "Pb", "Bi", "Po", "At", "Rn", "Fr", "Ra", "Ac", "Th", "Pa", "U"] 
## Transition =	[ {"K": "1s"},	{"L1": "2s"},	{"L2": "2p1/2"},	{"L3": "2p3/2"},	{"M1": "3s"},	{"M2": "3p1/2"},	{"M3": "3p3/2 "},	{"M4": "3d3/2"},	{"M5": "3d5/2"},	{"N1": "4s"},	{"N2": "4p1/2"},	{"N3": "4p3/2"},	{"N4": "4d3/2"},	{"N5": "4d5/2"},	{"N6": "4f5/2"},	{"N7": "4f7/2"},	{"O1": "5s"},	{"O2": "5p1/2 "},	{"O3": "5p3/2"},	{"O4": "5d3/2"},	{"O5": "5d5/2"},	{"P1": "6s"},	{"P2": "6p1/2"},	{"P3": "6p3/2"} ],

QNTransition = ["K","L1","L2","L3"]
edgeEnergy ={                                                                            
   "H"  :    [13.6  ],
   "He" :    [24.6  ],
   "Li" :    [54.7  ],
   "Be" :    [111.5 ],                                                                                                                                                                                                                                                                                                        
   "B"  :    [188   ],
   "C"  :    [284.2 ],      
   "N"  :    [409.9   , 37.3 ],
   "O"  :    [543.1   , 41.6 ],   
   "F"  :    [696.7],         
   "Ne" :    [870.2   , 48.5    , 21.7    , 21.6    ],
   "Na" :    [1070.8  , 63.5    , 30.65   , 30.81   ],                                                         
   "Mg" :    [1303.0  , 88.7    , 49.78   , 49.50   ],
   "Al" :    [1559.6  , 117.8   , 72.95   , 72.55   ],                                                                                                                                                                                                                                                                                                                                                                                                           
   "Si" :    [1839    , 149.7   , 99.82   , 99.42   ],
   "P"  :    [2145.5  , 189     , 136     , 135     ],
   "S"  :    [2472    , 230.9   , 163.6   , 162.5   ],
   "Cl" :    [2822.4  , 270     , 202     , 200     ],
   "Ar" :    [3205.9  , 326.3   , 250.6   , 248.4   , 29.3    , 15.9    , 15.7   ],
   "K"  :    [3608.4  , 378.6   , 297.3   , 294.6   , 34.8    , 18.3    , 18.3   ],
   "Ca" :    [4038.5  , 438.4   , 349.7   , 346.2   , 44.3    , 25.4    , 25.4   ],
   "Sc" :    [4492    , 498.0   , 403.6   , 398.7   , 51.1    , 28.3    , 28.3   ],
   "Ti" :    [4966    , 560.9   , 460.2   , 453.8   , 58.7    , 32.6    , 32.6   ],
   "V"  :    [5465    , 626.7   , 519.8   , 512.1   , 66.3    , 37.2    , 37.2   ],
   "Cr" :    [5989    , 696.0   , 583.8   , 574.1   , 74.1    , 42.2    , 42.2   ],
   "Mn" :    [6539    , 769.1   , 649.9   , 638.7   , 82.3    , 47.2    , 47.2   ],
   "Fe" :    [7112    , 844.6   , 719.9   , 706.8   , 91.3    , 52.7    , 52.7   ],
   "Co" :    [7709    , 925.1   , 793.2   , 778.1   , 101.0   , 58.9    , 59.9   ],
   "Ni" :    [8333    , 1008.6  , 870.0   , 852.7   , 110.8   , 68.0    , 66.2   ],
   "Cu" :    [8979    , 1096.7  , 952.3   , 932.7   , 122.5   , 77.3    , 75.1   ],
   "Zn" :    [9659    , 1196.2  , 1044.9  , 1021.8  , 139.8   , 91.4    , 88.6  ,  10.2   ,  10.1 ],
   "Ga" :    [10367   , 1299.0  , 1143.2  , 1116.4  , 159.5   , 103.5 ,  100.0  ,  18.7    , 18.7    ],
   "Ge" :    [11103   , 1414.6  , 1248.1  , 1217.0  , 180.1   ,  124.9   , 120.8   ,  29.8    , 29.2   ],
   "As" :    [11867   , 1527.0  , 1359.1  , 1323.6  , 204.7   ,  146.2   , 141.2   ,  41.7    , 41.7   ],
   "Se" :    [12658   , 1652.0  , 1474.3  , 1433.9  , 229.6   ,  166.5   , 160.7   ,  55.5    , 54.6   ],
   "Br" :    [13474   , 1782    , 1596    , 1550    , 257     , 189     , 182   ,  70     ,  69   ],  
   "Kr" :    [14326   , 1921    , 1730.9  , 1678.4  , 292.8   , 222.2   , 214.4 ,  95.0   ,  93.8    , 27.5    ,  14.1    , 14.1   ],
   "Rb" :    [15200   , 2065    , 1864    , 1804    , 326.7   , 248.7   , 239.1 ,  113.0  ,  112     , 30.5    ,  16.3    , 15.3   ],
   "Sr" :    [16105   , 2216    , 2007    , 1940    , 358.7   , 280.3   , 270.0 ,  136.0  ,  134.2   , 38.9    ,  21.3    , 20.1   ],
   "Y"  :    [17038   , 2373    , 2156    , 2080    , 392.0   , 310.6   , 298.8 ,  157.7  ,  155.8   , 43.8    ,  24.4    , 23.1   ],
   "Zr" :    [17998   , 2532    , 2307    , 2223    , 430.3   , 343.5   , 329.8 ,  181.1  ,  178.8   , 50.6    ,  28.5    , 27.1   ],
   "Nb" :    [18986   , 2698    , 2465    , 2371    , 466.6   , 376.1   , 360.6 ,  205.0  ,  202.3   , 56.4    ,  32.6    , 30.8   ],
   "Mo" :    [20000   , 2866    , 2625    , 2520    , 506.3   , 411.6   , 394.0 ,  231.1  ,  227.9   , 63.2    ,  37.6    , 35.5   ],
   "Tc" :    [21044   , 3043    , 2793    , 2677    , 544     , 447.6   , 417.7 ,  257.6  ,  253.9   , 69.5    ,  42.3    , 39.9   ],
   "Ru" :    [22117   , 3224    , 2967    , 2838    , 586.1   , 483.5   , 461.4 ,  284.2  ,  280.0   , 75.0    ,  46.3    , 43.2   ],
   "Rh" :    [23220   , 3412    , 3146    , 3004    , 628.1   , 521.3   , 496.5 ,  311.9  ,  307.2   , 81.4    ,  50.5    , 47.3   ],
   "Pd" :    [24350   , 3604    , 3330    , 3173    , 671.6   , 559.9   , 532.3 ,  340.5  ,  335.2   , 87.1    ,  55.7    , 50.9   ],      
   "Ag" :    [25514   , 3806    , 3524    , 3351    , 719.0   , 603.8   , 573.0 ,  374.0  ,  368.3   , 97.0    ,  63.7    , 58.3   ], 
   "Cd" :    [26711   , 4018    , 3727    , 3538    , 772.0   , 652.6   , 618.4 ,  411.9  ,  405.2   , 109.8   ,  63.9    , 63.9    , 11.7    , 10.7    ],                                                      
   "In" :    [27940   , 4238    , 3938    , 3730    , 827.2   , 703.2   , 665.3 ,  451.4  ,  443.9   , 122.9   ,  73.5    , 73.5    , 17.7    , 16.9    ],
   "Sn" :    [29200   , 4465    , 4156    , 3929    , 884.7   , 756.5   , 714.6 ,  493.2  ,  484.9   , 137.1   ,  83.6    , 83.6    , 24.9    , 23.9    ],                                                                            
   "Sb" :    [30491   , 4698    , 4380    , 4132    , 946     , 812.7   , 766.4 ,  537.5  ,  528.2   , 153.2   ,  95.6    , 95.6    , 33.3    , 32.1    ],
   "Te" :    [31814   , 4939    , 4612    , 4341    , 1006    , 870.8   , 820.0 ,  583.4  ,  573.0   , 169.4   ,  103.3   , 103.3   , 41.9    , 40.4    ],
   "I"  :    [33169   , 5188    , 4852    , 4557    , 1072    , 931     , 875   ,  630.8  ,  619.3   , 186     ,  123     , 123     , 50.6    , 48.9    ],
   "Xe" :    [34561   , 5453    , 5107    , 4786    , 1148.7  , 1002.1  , 940.6 ,  689.0  ,  676.4   , 213.2   ,  146.7   , 145.5   , 69.5    , 67.5    , 23.3    , 13.4    , 12.1    ],
   "Cs" :    [35985   , 5714    , 5359    , 5012    , 1211    , 1071    , 1003  ,  740.5  ,  726.6   , 232.3   ,  172.4   , 161.3   , 79.8    , 77.5    , 22.7    , 14.2    , 12.1    ],
   "Ba" :    [37441   , 5989    , 5624    , 5247    , 1293    , 1137    , 1063  ,  795.7  ,  780.5   , 253.5   ,  192     , 178.6   , 92.6    , 89.9    , 30.3    , 17.0    , 14.8    ],
   "La" :    [38925   , 6266    , 5891    , 5483    , 1362    , 1209    , 1128  ,  853    ,  836     , 274.7   ,  205.8   , 196.0   , 105.3   , 102.5   , 34.3    , 19.3    , 16.8    ],
   "Ce" :    [40443   , 6549    , 6164    , 5723    , 1436    , 1274    , 1187  ,  902.4  ,  883.8   , 291.0   ,  223.2   , 206.5   , 109     , 0.1    , 0.1     , 37.8    , 19.8    , 17.0    ],
   "Pr" :    [41991   , 6835    , 6440    , 5964    , 1511    , 1337    , 1242  ,  948.3  ,  928.8   , 304.5   ,  236.3   , 217.6   , 115.1   , 115.1   , 2.0    , 2.0     , 37.4    , 22.3    , 22.3    ],
   "Nd" :    [43569   , 7126    , 6722    , 6208    , 1575    , 1403    , 1297  ,  1003.3 ,  980.4   , 319.2   ,  243.3   , 224.6   , 120.5   , 120.5   , 1.5    , 1.5     , 37.5    , 21.1    , 21.1    ],     
   "Pm" :    [45184   , 7428    , 7013    , 6459    , 1471    , 1357  ,  1052   ,  1027   ,  242     , 242     , 120     , 120     ],  
   "Sm" :    [46834   , 7737    , 7312    , 6716    , 1723    , 1541    , 1420  ,  1110.9 ,  1083.4  , 347.2   ,  265.6   , 247.4   , 129     , 129     , 5.2    , 5.2     , 37.4    , 21.3    , 21.3    ],
   "Eu" :    [48519   , 8052    , 7617    , 6977    , 1800    , 1614    , 1481  ,  1158.6 ,  1127.5  , 360     ,  284     , 257     , 133     , 127.7   , 0      , 0       , 32      , 22      , 22      ],  
   "Gd" :    [50239   , 8376    , 7930    , 7243    , 1881    , 1688    , 1544  ,  1221.9 ,  1189.6  , 378.6   ,  286     , 271     , 142.6   , 8.6    , 8.6     , 36      , 28      , 21      ],
   "Tb" :    [51996   , 8708    , 8252    , 7514    , 1968    , 1768    , 1611  ,  1276.9 ,  1241.1  , 396.0   ,  322.4   , 284.1   , 150.5   , 150.5   , 7.7    , 2.4     , 45.6    , 28.7    , 22.6    ],
   "Dy" :    [53789   , 9046    , 8581    , 7790    , 2047    , 1842    , 1676  ,  1333   ,  1292.6  , 414.2   ,  333.5   , 293.2   , 153.6   , 153.6   , 8.0    , 4.3     , 49.9    , 26.3    , 26.3    ],
   "Ho" :    [55618   , 9394    , 8918    , 8071    , 2128    , 1923    , 1741  ,  1392   ,  1351    , 432.4   ,  343.5   , 308.2   , 160     , 160     , 8.6    , 5.2     , 49.3    , 30.8    , 24.1    ],
   "Er" :    [57486   , 9751    , 9264    , 8358    , 2207    , 2006    , 1812  ,  1453   ,  1409    , 449.8   ,  366.2   , 320.2   , 167.6   , 167.6   , 4.7     , 50.6    , 31.4    , 24.7    ],
   "Tm" :    [59390   , 10116   , 9617    , 8648    , 2307    , 2090    , 1885  ,  1515   ,  1468    , 470.9   ,  385.9   , 332.6   , 175.5   , 175.5   , 4.6     , 54.7    , 31.8    , 25.0    ],
   "Yb" :    [61332   , 10486   , 9978    , 8944    , 2398    , 2173    , 1950  ,  1576   ,  1528    , 480.5   ,  388.7   , 339.7   , 191.2   , 182.4   , 2.5    , 1.3     , 52.0    , 30.3    , 24.1    ],
   "Lu" :    [63314   , 10870   , 10349   , 9244    , 2491    , 2264    , 2024  ,  1639   ,  1589    , 506.8   ,  412.4   , 359.2   , 206.1   , 196.3   , 8.9    , 7.5     , 57.3    , 33.6    , 26.7    ],
   "Hf" :    [65351   , 11271   , 10739   , 9561    , 2601    , 2365    , 2108  ,  1716   ,  1662    , 538     ,  438.2   , 380.7   , 220.0   , 211.5   , 15.9   , 14.2    , 64.2    , 38      , 29.9    ],
   "Ta" :    [67416   , 11682   , 11136   , 9881    , 2708    , 2469    , 2194  ,  1793   ,  1735    , 563.4   ,  463.4   , 400.9   , 237.9   , 226.4   , 23.5   , 21.6    , 69.7    , 42.2    , 32.7    ],
   "W"  :    [69525   , 12100   , 11544   , 10207   , 2820    , 2575    , 2281  ,  1872   ,  1809    , 594.1   ,  490.4   , 423.6   , 255.9   , 243.5   , 33.6   , 31.4    , 75.6    , 45.3    , 36.8    ],
   "Re" :    [71676   , 12527   , 11959   , 10535   , 2932    , 2682    , 2367  ,  1949   ,  1883    , 625.4   ,  518.7   , 446.8   , 273.9   , 260.5   , 42.9   , 40.5    , 83      , 45.6    , 34.6    ],
   "Os" :    [73871   , 12968   , 12385   , 10871   , 3049    , 2792    , 2457  ,  2031   ,  1960    , 658.2   ,  549.1   , 470.7   , 293.1   , 278.5   , 53.4   , 50.7    , 84      , 58      , 44.5    ],
   "Ir" :    [76111   , 13419   , 12824   , 11215   , 3174    , 2909    , 2551  ,  2116   ,  2040    , 691.1   ,  577.8   , 495.8   , 311.9   , 296.3   , 63.8   , 60.8    , 95.2    , 63.0    , 48.0    ],
   "Pt" :    [78395   , 13880   , 13273   , 11564   , 3296    , 3027    , 2645  ,  2202   ,  2122    , 725.4   ,  609.1   , 519.4   , 331.6   , 314.6   , 74.5   , 71.2    , 101.7   , 65.3    , 51.7    ],
   "Au" :    [80725   , 14353   , 13734   , 11919   , 3425    , 3148    , 2743  ,  2291   ,  2206    , 762.1   ,  642.7   , 546.3   , 353.2   , 335.1   , 87.6   , 84.0    , 107.2   , 74.2    , 57.2    ],
   "Hg" :    [83102   , 14839   , 14209   , 12284   , 3562    , 3279    , 2847  ,  2385   ,  2295    , 802.2   ,  680.2   , 576.6   , 378.2   , 358.8   , 104.0  , 99.9    , 127     , 83.1    , 64.5    , 9.6     , 7.8     ],
   "Tl" :    [85530   , 15347   , 14698   , 12658   , 3704    , 3416    , 2957  ,  2485   ,  2389    , 846.2   ,  720.5   , 609.5   , 405.7   , 385.0   , 122.2  , 117.8   , 136.0   , 94.6    , 73.5    , 14.7    , 12.5    ],
   "Pb" :    [88005   , 15861   , 15200   , 13035   , 3851    , 3554    , 3066  ,  2586   ,  2484    , 891.8   ,  761.9   , 643.5   , 434.3   , 412.2   , 141.7  , 136.9   , 147     , 106.4   , 83.3    , 20.7    , 18.1    ],
   "Bi" :    [90524   , 16388   , 15711   , 13419   , 3999    , 3696    , 3177  ,  2688   ,  2580    , 939     ,  805.2   , 678.8   , 464.0   , 440.1   , 162.3  , 157.0   , 159.3   , 119.0   , 92.6    , 26.9    , 23.8    ],
   "Po" :    [93105   , 16939   , 16244   , 13814   , 4149    , 3854    , 3302  ,  2798   ,  2683    , 995     ,  851     , 705     , 500     , 473     , 184    , 184     , 177     , 132     , 104     , 31      , 31      ],
   "At" :    [95730   , 17493   , 16785   , 14214   , 4317    , 4008    , 3426  ,  2909   ,  2787    , 1042    ,  886     , 740     , 533     , 507     , 210    , 210     , 195     , 148     , 115     , 40      , 40      ],
   "Rn" :    [98404   , 18049   , 17337   , 14619   , 4482    , 4159    , 3538  ,  3022   ,  2892    , 1097    ,  929     , 768     , 567     , 541     , 238    , 238     , 214     , 164     , 127     , 48      , 48      , 26 ],
   "Fr" :    [101137  , 18639   , 17907   , 15031   , 4652    , 4327    , 3663  ,  3136   ,  3000    , 1153    ,  980     , 810     , 603     , 577     , 268    , 268     , 234     , 182     , 140     , 58      , 58      , 34      , 15      ,15      ],
   "Ra" :    [103922  , 19237   , 18484   , 15444   , 4822    , 4490    , 3792  ,  3248   ,  3105    , 1208    ,  1058    , 879     , 636     , 603     , 299    , 299     , 254     , 200     , 153     , 68      , 68      , 44      , 19      ,19      ],
   "Ac" :    [106755  , 19840   , 19083   , 15871   , 5002    , 4656    , 3909  ,  3370   ,  3219    , 1269    ,  1080    , 890     , 675     , 639     , 319    , 319     , 272     , 215     , 167     , 80      , 80      ],       
   "Th" :    [109651  , 20472   , 19693   , 16300   , 5182    , 4830    , 4046  ,  3491   ,  3332    , 1330    ,  1168    , 966.4   , 712.1   , 675.2   , 342.4  , 333.1   , 290     , 229     , 182     , 92.5    , 85.4    , 41.4    , 24.5    ,16.6    ],
   "Pa" :    [112601  , 21105   , 20314   , 16733   , 5367    , 5001    , 4174  ,  3611   ,  3442    , 1387    ,  1224    , 1007    , 743     , 708     , 371    , 360     , 310     , 232     , 232     , 94      , 94      ],       
   "U"  :    [115606  , 21757   , 20948   , 17166   , 5548    , 5182    , 4303  ,  3728   ,  3552    , 1439    ,  1271    , 1043    , 778.3   , 736.2   , 388.2  , 377.4   , 321     , 257     , 192     , 102.8   , 94.2    , 43.9    , 26.8    ,16.8    ]}
   
   
#
# edges accessible at the beamline (here AS-XAS beamline (4.9-40 keV))
#    (note: M-edges of  Ac, Th, Pa, U  excluded)
#
edgesAvailable = ["Ti-K", "V-K", "Cr-K", "Mn-K", "Fe-K", "Co-K", "Ni-K",
                  "Cu-K", "Zn-K", "Ga-K", "As-K", "Se-K", "Br-K", "Kr-K",
                  "Rb-K", "Sr-K", "Y-K", "Zr-K", "Nb-K", "Mo-K", "Tc-K",
                  "Ru-K", "Rh-K", "Pd-K", "Ag-K", "Cd-K", "In-K", "Sn-K",
                  "Sb-K", "Te-K", "Te-L1", "I-K", "I-L1", "I-L2", "Xe-K",
                  "Xe-L1", "Xe-L2", "Cs-K", "Cs-L1", "Cs-L2", "Cs-L3",
                  "Ba-K", "Ba-L1", "Ba-L2", "Ba-L3",
                  "La-K", "La-L1", "La-L2", "La-L3",
                  "Ce-K", "Ce-L1", "Ce-L2", "Ce-L3",
                  "Pr-K", "Pr-L1", "Pr-L2", "Pr-L3",
                  "Nd-L1", "Nd-L2", "Nd-L3",
                  "Pm-L1", "Pm-L2", "Pm-L3",
                  "Sm-L1", "Sm-L2", "Sm-L3",
                  "Eu-L1", "Eu-L2", "Eu-L3",
                  "Gd-L1", "Gd-L2", "Gd-L3",
                  "Tb-L1", "Tb-L2", "Tb-L3",
                  "Dy-L1", "Dy-L2", "Dy-L3",
                  "Ho-L1", "Ho-L2", "Ho-L3",
                  "Er-L1", "Er-L2", "Er-L3",
                  "Tm-L1", "Tm-L2", "Tm-L3",
                  "Yb-L1", "Yb-L2", "Yb-L3",
                  "Lu-L1", "Lu-L2", "Lu-L3",
                  "Hf-L1", "Hf-L2", "Hf-L3",
                  "Ta-L1", "Ta-L2", "Ta-L3",
                  "W-L1", "W-L2", "W-L3",
                  "Re-L1", "Re-L2", "Re-L3",
                  "Os-L1", "Os-L2", "Os-L3",
                  "Ir-L1", "Ir-L2", "Ir-L3",
                  "Pt-L1", "Pt-L2", "Pt-L3",
                  "Au-L1", "Au-L2", "Au-L3",
                  "Hg-L1", "Hg-L2", "Hg-L3",
                  "Tl-L1", "Tl-L2", "Tl-L3",
                  "Pb-L1", "Pb-L2", "Pb-L3",
                  "Bi-L1", "Bi-L2", "Bi-L3",
                  "Po-L1", "Po-L2", "Po-L3",
                  "At-L1", "At-L2", "At-L3",
                  "Rn-L1", "Rn-L2", "Rn-L3",
                  "Fr-L1", "Fr-L2", "Fr-L3",
                  "Th-L1", "Th-L2", "Th-L3",
                  "Pa-L1", "Pa-L2", "Pa-L3",
                  "U-L1", "U-L2", "U-L3"
                  ]


  
